/**
 * psExporter.h
 *
 * a class to export a nodes class into a postscript file
 */

#ifndef __PSEXPORTER_H__
#define __PSEXPORTER_H__

#include <fstream>
#include <stdio.h>
#include "nodes.h"

class psExporter {

    public:
        psExporter(char *what_file, nodes *what_nodes);   // constructor

        void do_export();  // effects the export


    private:
        std::string s_filename;
        nodes *my_nodes;
        int smallest_x, smallest_y, biggest_x, biggest_y;
        int margin;
        double scale_factor;


        void write_headers(std::ofstream &outfile);
        void find_bounds();
        void write_nodes(std::ofstream &outfile);
        void write_node(node *this_node, std::ofstream &outfile);
        void write_edges(std::ofstream &outfile);
        void write_edge(node *from_node, node *to_node, std::ofstream &outfile);

        // utility
        int translatexcoord(double x);
        int translateycoord(double y);
};


#endif
